% Optimizer settings
opts_fsolve_fmincon=optimoptions('fsolve','Display','off',...
                                 'TolFun',1e-9,'UseParallel',false,...
                                 'MaxFunctionEvaluations',1000000,...
                                 'MaxIterations',100);

% opts_fmincon=optimoptions('fmincon','Display','iter',...
%                           'MaxFunctionEvaluations',1000000,...,
%                           'FunctionTolerance',1e-5,...
%                           'MaxIterations',10000,...,
%                           'UseParallel',true,...
%                           'FiniteDifferenceStepSize',1e-3,...
%                           'MaxIterations',200);

opts_fmincon=optimoptions('fmincon','Display','iter',...
                          'MaxFunctionEvaluations',1000000,...,
                          'FunctionTolerance',mintol,...
                          'MaxIterations',maxiter,...,
                          'FiniteDifferenceStepSize',1e-3,...
                          'UseParallel',true);

n_vec_guess = [lrss*ones(2*HH,1);...
               xrss*deltaHss*ones(1*HH,1);xrss*deltaFss*ones(1*HH,1);...
               xrss*deltaHss*ones(1*HH,1);xrss*deltaFss*ones(1*HH,1);...
               1*ones(HH,1)];

[optimalpolicy,fval_planner,exitflag_planner] = ...
    fmincon(@getU,init_guess,[],[],[],[],LB,UB,[],opts_fmincon,...
            n_vec_guess,opts_fsolve_fmincon,HH,policylength,granularity,...
            beta,z,zstar,kappa,alpha,...
            sigma,I0,Istar0,pop0,popstar0,pi1,pi2,pi3,pi4,...
            pir,pid,pid_accel,phi,Uiss,Urss,Udeath,delta_muin,delta_nuin,3);


getU(optimalpolicy,...
     n_vec_guess,opts_fsolve_fmincon,HH,policylength,granularity,...
     beta,z,zstar,kappa,alpha,...
     sigma,I0,Istar0,pop0,popstar0,pi1,pi2,pi3,pi4,...
     pir,pid,pid_accel,phi,Uiss,Urss,Udeath,delta_muin,delta_nuin,3)


muh = zeros(HH,1);
muf = zeros(HH,1);
muhstar = zeros(HH,1);
mufstar = zeros(HH,1);

muh(1:policylength) = kron(optimalpolicy(1:n_per),ones(1,granularity));
muf(1:policylength) = kron(optimalpolicy((n_per+1):(2*n_per)),ones(1,granularity));
muhstar(1:policylength) = kron(optimalpolicy((2*n_per+1):(3*n_per)),ones(1,granularity));
mufstar(1:policylength) = kron(optimalpolicy((3*n_per+1):(4*n_per)),ones(1,granularity));

Model_Solution;

save(savefile)
